<?php namespace RWMediaIntegration;

class Database {
	
	public static function insertOg($args) {
		
		[
			'node' => $node,
			'description' => $description,
			'imageUrl' => $imageUrl,
		] = $args;
		
		if (isset($description)) {
			$fieldLanguage = field_language('node', $node, 'field_og_description'); //load body field's language, if any
			$node->field_og_description[$fieldLanguage][0]['value'] = $description;
		}
		
		if (isset($imageUrl)) {
			$fieldLanguage = field_language('node', $node, 'field_og_image'); //load body field's language, if any
			$node->field_og_image[$fieldLanguage][0]['value'] = $imageUrl;
		}
		
		field_attach_presave('node', $node); // Let other modules process the field input properly
		field_attach_update('node', $node); //Drupal: update only the changed fields on DB
	}

	public static function createOgDescription($node) {
		
		$type = $node->type;
		
		if ($type === 'forum') {
			$body = field_get_items('node', $node, 'body');  //load content, Forum Topic body only
			
			$fieldLanguage = field_language('node', $node, 'body'); //load body field's language, if any
			$string = $node->body[$fieldLanguage][0]['value'];  //load raw value
		}
		else if ($type === 'poll') {
			$body1 = field_get_items('node', $node, 'field_pollbody3');  //Load Voting top field
			$body2 = field_get_items('node', $node, 'field_pollbody4');  //Load Voting bottom field
			
			$fieldLanguage1 = field_language('node', $node, 'field_pollbody3'); //Voting top body field's language, if any
			$fieldLanguage2 = field_language('node', $node, 'field_pollbody4'); //Voting bottom body field's language, if any
			
			$string1 = $node->field_pollbody3[$fieldLanguage1][0]['value'] ?? ""; //load Voting top field's body content
			$string2 = $node->field_pollbody4[$fieldLanguage2][0]['value'] ?? ""; //load Voting bottom field's body content
			
			$string = $string1 . $string2;
		}
		else {
			$string = "REWiRED - Kutyus felfedo szétszéledés - 2014-2057 © Minden Jog Fenntartva!" .
				"Virtuális valóság és Kecskeklónozó központ - Oculus MegaRift - PS21 - Mozi - 4D - Bajuszpödrés" .
				"Médiaajánlat/Borsós Brassói Árak" .
				"Rohadt Impresszum!";
		}
		
		//to escape reserved square brackets in drupal
		//$pattern = "/&#91;a-zA-Z&#93;*&#91;:\/\/&#93;*&#91;A-Za-z0-9\-_&#93;+\.+&#91;A-Za-z0-9\.\/%&=\?\-_&#93;+/i";
		//$pattern = html_entity_decode($pattern); 
		$string = strip_tags($string); //strip html tags
		$string = preg_replace("/[a-zA-Z]*[:\/\/]*[A-Za-z0-9\-_]+\.+[A-Za-z0-9\.\/%&=\?\-_]+/i", "", $string); //strip links
		$string = str_replace(array("\r","\n"), "", $string); //strip linebreaks
		$string = preg_replace('#\[[^\]]+\]#', "", $string); //strip bbcodes
		$string = html_entity_decode($string);
		$string = mb_substr($string, 0, 240, 'UTF-8') . "..."; //strip to 240 characters, mb_substr=UTF-8 fix

		return $string;
	}
	
}

?>